#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <stdio.h>


#define LARGEUR 6
#define HAUTEUR 6
#define ENTREE (LARGEUR * HAUTEUR) 
#define CACHE (LARGEUR)
#define SORTIE (LARGEUR)

#define MAX_POPULATION 100
#define MAX_GENERATION 200

#define TAUX_CROSSOVER 50
#define TAUX_MUTATION 10

#define DELTA_MUTATION 25
#define PROB_MUTATION 10

#define GAIN_GAGNE (3 * coup_joue)
#define GAIN_PERDU (1 * coup_joue)
#define GAIN_EGALITE (6 * coup_joue)

#define IMPORTANCE 1

#define DEBUG if(0) printf

int terrain[LARGEUR][HAUTEUR];
double poids_entree[MAX_POPULATION][ENTREE+1][CACHE];
double poids_cache[MAX_POPULATION][CACHE][SORTIE];

int gain[MAX_POPULATION];


int main(void);
int joue(int , int);
int couleur (int pion, int monpion);
double sigmoid (double num);
void initialisation_terrain(void);
void affecte_terrain(int coup, int pion);
int faire_jouer( int, int);
void initialisation_gain(void); 
int gagne(int);
void nouvelle_population(void);
void affiche_terrain(void);
